unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, ExtCtrls, RASControl;

type
  TMain = class(TForm)
    Panel2: TPanel;
    Panel1: TPanel;
    btnClose: TButton;
    btnMonitor: TButton;
    ListBox1: TListBox;
    GroupBox2: TGroupBox;
    CheckBox1: TCheckBox;
    btnSetUserInfo: TButton;
    ebUserName: TEdit;
    Label9: TLabel;
    Label10: TLabel;
    ebPassword: TEdit;
    GroupBox3: TGroupBox;
    btnDial: TButton;
    btnHangUp: TButton;
    GroupBox4: TGroupBox;
    btnPhone: TButton;
    btnRasDlg: TButton;
    btnRefreshEntry: TButton;
    btnRefreshList: TButton;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    lblCurrentStatus: TLabel;
    lblUserName: TLabel;
    lblPassword: TLabel;
    lblDevType: TLabel;
    lblDevName: TLabel;
    lblConnHandle: TLabel;
    Label7: TLabel;
    Label6: TLabel;
    lblError: TLabel;
    Label8: TLabel;
    lblPhone: TLabel;
    RC: TRASControl;
    procedure FormCreate(Sender: TObject);
    procedure btnCloseClick(Sender: TObject);
    procedure btnHangUpClick(Sender: TObject);
    procedure btnDialClick(Sender: TObject);
    procedure btnMonitorClick(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure btnRasDlgClick(Sender: TObject);
    procedure btnPhoneClick(Sender: TObject);
    procedure btnSetUserInfoClick(Sender: TObject);
    procedure btnRefreshEntryClick(Sender: TObject);
    procedure btnRefreshListClick(Sender: TObject);
    procedure RCConnectionStatus(Sender: TObject; EntryIndex, rasStatus,
      rasError: Integer);
    procedure RCEntryListChange(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure LoadListBox;
  end;

var
  Main: TMain;
//  RC: TRASControl;

implementation

{$R *.DFM}

procedure TMain.FormCreate(Sender: TObject);
begin
//  RC := TRASControl.Create(nil);
//  RC.OnConnectionStatus := RCConnectionStatus;
  LoadListBox;
  if RC.MonitorConnections then
    btnMonitor.Caption := 'Turn Connection &Monitor Off'
  else
    btnMonitor.Caption := 'Turn Connection &Monitor On';
end;

procedure TMain.FormDestroy(Sender: TObject);
begin
//  RC.Free;
end;

procedure TMain.LoadListBox;
begin
  // Copy the phonebook entry names to a list box for easy viewing

  ListBox1.Items.Clear;
  ListBox1.Items.Assign(RC.Entries);
end;

procedure TMain.btnCloseClick(Sender: TObject);
begin
  Close;
end;

procedure TMain.btnHangUpClick(Sender: TObject);
begin
  // Dial the phonebook entry the user has selected in the listbox

  RC.HangUpEntry(ListBox1.ItemIndex);
end;

procedure TMain.btnDialClick(Sender: TObject);
begin
  // Hang-up the phonebook entry the user has selected in the listbox
  // This works with connections not started by TRASControl as well
  RC.UserName[ListBox1.ItemIndex] := ebUserName.Text; 
  RC.Password[ListBox1.ItemIndex] := ebPassword.Text;
  RC.DialEntry(ListBox1.ItemIndex);
end;

procedure TMain.btnMonitorClick(Sender: TObject);
begin
  // Turn constant monitoring on or off...
  // A seperate thread is created to monitor active RAS connections

  RC.MonitorConnections := not RC.MonitorConnections;
  if RC.MonitorConnections then
    btnMonitor.Caption := 'Turn Connection &Monitor Off'
  else
    btnMonitor.Caption := 'Turn Connection &Monitor On';
end;

procedure TMain.ListBox1Click(Sender: TObject);
begin
  // Update the status display fields with current data when the user selects
  // an entry in the ListBox

  GroupBox1.Caption := 'Properties for '+RC.EntryName[ListBox1.ItemIndex];
  lblCurrentStatus.Caption := RC.StatusString(RC.rasConnState[ListBox1.ItemIndex]);

  lblUserName.Caption := RC.UserName[ListBox1.ItemIndex];

  ebUserName.Text := RC.UserName[ListBox1.ItemIndex];
  ebPassword.Text := RC.Password[ListBox1.ItemIndex];
  if RC.lbHasPassword[ListBox1.ItemIndex] then
    lblPassword.Caption := 'Yes'
  else
    lblPassword.Caption := 'No';

  lblPhone.Caption := RC.PhoneNumber[ListBox1.ItemIndex];
  lblDevType.Caption := RC.DeviceType[ListBox1.ItemIndex];
  lblDevName.Caption := RC.DeviceName[ListBox1.ItemIndex];
  lblConnHandle.Caption := IntToStr(RC.hRasConn[ListBox1.ItemIndex]);
  lblError.Caption := RC.ErrorString(RC.rasConnError[ListBox1.ItemIndex]);
end;

procedure TMain.btnRasDlgClick(Sender: TObject);
begin
  // Opens Windows entry editor dialog

  RC.OSEditEntry(ListBox1.ItemIndex);
end;

procedure TMain.btnPhoneClick(Sender: TObject);
begin
  // Opens Windows new entry dialog

  RC.OSAddEntry;
end;

procedure TMain.btnSetUserInfoClick(Sender: TObject);
begin
  // Changes the stored data for the entry
  RC.UserName[ListBox1.ItemIndex] := ebUserName.Text;
  RC.Password[ListBox1.ItemIndex] := ebPassword.Text;
  RC.SetDialParams(ListBox1.ItemIndex, not CheckBox1.Checked);
end;

procedure TMain.btnRefreshEntryClick(Sender: TObject);
begin
  // Reloads the entry's data...
  // the OnConnectionStatus event will fire to let
  // you know when the data has been reloaded

  RC.RefreshRASEntry(ListBox1.ItemIndex);
end;

procedure TMain.btnRefreshListClick(Sender: TObject);
begin
  // clear and reload TRASControl's internal entry list
  // the OnEntryListChange event will fire to let
  // you know when the component is updated

  RC.LoadRASEntryList;
end;

procedure TMain.RCConnectionStatus(Sender: TObject; EntryIndex, rasStatus,
  rasError: Integer);
begin
  // When a connection is in progress, this event fires when a change
  // in the connection's status is detected, but only for connections
  // started by TRASControl.  If you want to monitor connections made
  // by other applications, set the MonitorConnections property to True

  if EntryIndex = ListBox1.ItemIndex then begin
    GroupBox1.Caption := 'Properties for '+RC.EntryName[EntryIndex];
    lblCurrentStatus.Caption := RC.StatusString(rasStatus);
    lblUserName.Caption := RC.UserName[EntryIndex];

    if RC.lbHasPassword[EntryIndex] then
      lblPassword.Caption := 'Yes'
    else
      lblPassword.Caption := 'No';

    lblPhone.Caption := RC.PhoneNumber[EntryIndex];
    lblDevType.Caption := RC.DeviceType[EntryIndex];
    lblDevName.Caption := RC.DeviceName[EntryIndex];
    lblConnHandle.Caption := IntToStr(RC.hRasConn[EntryIndex]);
    lblError.Caption := RC.ErrorString(rasError);
  end;
end;

procedure TMain.RCEntryListChange(Sender: TObject);
begin
  // When TRASControl's internal list of phonebook entries has changed
  // this event will fire notifying you of a change

  LoadListBox;
end;

end.
